"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function id(d) { return d[0]; }
var unpack = function (data) { return data[0]; };
var Fragment = (function () {
    function Fragment(type, data) {
        this.type = type;
        this.data = data;
    }
    return Fragment;
}());
exports.default = Fragment;
;
;
;
exports.Lexer = undefined;
exports.ParserRules = [
    { "name": "_$ebnf$1", "symbols": [] },
    { "name": "_$ebnf$1", "symbols": ["_$ebnf$1", "wschar"], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "_", "symbols": ["_$ebnf$1"], "postprocess": function () { return null; } },
    { "name": "__$ebnf$1", "symbols": ["wschar"] },
    { "name": "__$ebnf$1", "symbols": ["__$ebnf$1", "wschar"], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "__", "symbols": ["__$ebnf$1"], "postprocess": function () { return null; } },
    { "name": "wschar", "symbols": [/[ \t\n\v\f]/], "postprocess": id },
    { "name": "nullLiteral$string$1", "symbols": [{ "literal": "n" }, { "literal": "u" }, { "literal": "l" }, { "literal": "l" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "nullLiteral", "symbols": ["nullLiteral$string$1"], "postprocess": function () { return null; } },
    { "name": "boolean$string$1", "symbols": [{ "literal": "t" }, { "literal": "r" }, { "literal": "u" }, { "literal": "e" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "boolean", "symbols": ["boolean$string$1"], "postprocess": function () { return true; } },
    { "name": "boolean$string$2", "symbols": [{ "literal": "f" }, { "literal": "a" }, { "literal": "l" }, { "literal": "s" }, { "literal": "e" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "boolean", "symbols": ["boolean$string$2"], "postprocess": function () { return false; } },
    { "name": "char", "symbols": [{ "literal": "'" }, "sstrchar", { "literal": "'" }], "postprocess": function (data) { return data[1]; } },
    { "name": "number$ebnf$1", "symbols": [{ "literal": "-" }], "postprocess": id },
    { "name": "number$ebnf$1", "symbols": [], "postprocess": function () { return null; } },
    { "name": "number$ebnf$2", "symbols": [/[0-9]/] },
    { "name": "number$ebnf$2", "symbols": ["number$ebnf$2", /[0-9]/], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "number$ebnf$3$subexpression$1$ebnf$1", "symbols": [/[0-9]/] },
    { "name": "number$ebnf$3$subexpression$1$ebnf$1", "symbols": ["number$ebnf$3$subexpression$1$ebnf$1", /[0-9]/], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "number$ebnf$3$subexpression$1", "symbols": [{ "literal": "." }, "number$ebnf$3$subexpression$1$ebnf$1"] },
    { "name": "number$ebnf$3", "symbols": ["number$ebnf$3$subexpression$1"], "postprocess": id },
    { "name": "number$ebnf$3", "symbols": [], "postprocess": function () { return null; } },
    { "name": "number", "symbols": ["number$ebnf$1", "number$ebnf$2", "number$ebnf$3"], "postprocess": function (data) {
            return parseFloat("" + (data[0] || '') + data[1].join('') + (data[2] ? '.' + data[2][1].join('') : ''));
        }
    },
    { "name": "unsigned_int$ebnf$1", "symbols": [/[0-9]/] },
    { "name": "unsigned_int$ebnf$1", "symbols": ["unsigned_int$ebnf$1", /[0-9]/], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "unsigned_int", "symbols": ["unsigned_int$ebnf$1"], "postprocess": function (data) { return parseInt(data[0].join('')); } },
    { "name": "string", "symbols": ["dqstring"] },
    { "name": "string", "symbols": ["sqstring"], "postprocess": unpack },
    { "name": "dqstring$ebnf$1", "symbols": [] },
    { "name": "dqstring$ebnf$1", "symbols": ["dqstring$ebnf$1", "dstrchar"], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "dqstring", "symbols": [{ "literal": "\"" }, "dqstring$ebnf$1", { "literal": "\"" }], "postprocess": function (data) { return data[1].join(''); } },
    { "name": "sqstring$ebnf$1", "symbols": [] },
    { "name": "sqstring$ebnf$1", "symbols": ["sqstring$ebnf$1", "sstrchar"], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "sqstring", "symbols": [{ "literal": "'" }, "sqstring$ebnf$1", { "literal": "'" }], "postprocess": function (data) { return data[1].join(''); } },
    { "name": "dstrchar", "symbols": [/[^\\"\n]/], "postprocess": id },
    { "name": "dstrchar", "symbols": [{ "literal": "\\" }, "strescape"], "postprocess": function (data) { return JSON.parse("\"" + data.join('') + "\""); } },
    { "name": "sstrchar", "symbols": [/[^\\'\n]/], "postprocess": id },
    { "name": "sstrchar", "symbols": [{ "literal": "\\" }, "strescape"], "postprocess": function (data) { return JSON.parse("\"" + data.join('') + "\""); } },
    { "name": "sstrchar$string$1", "symbols": [{ "literal": "\\" }, { "literal": "'" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "sstrchar", "symbols": ["sstrchar$string$1"], "postprocess": function () { return '\''; } },
    { "name": "strescape", "symbols": [/["\\\/bfnrt]/], "postprocess": id },
    { "name": "strescape", "symbols": [{ "literal": "u" }, /[a-fA-F0-9]/, /[a-fA-F0-9]/, /[a-fA-F0-9]/, /[a-fA-F0-9]/], "postprocess": function (data) { return data.join(''); } },
    { "name": "grammar", "symbols": ["fragment"], "postprocess": unpack },
    { "name": "fragment", "symbols": ["union"], "postprocess": unpack },
    { "name": "union", "symbols": ["intersection"], "postprocess": unpack },
    { "name": "union", "symbols": ["union", "_", { "literal": "|" }, "_", "intersection"], "postprocess": function (data) {
            return new Fragment('union', { type: data[0], type2: data[4] });
        }
    },
    { "name": "intersection", "symbols": ["nullable"], "postprocess": unpack },
    { "name": "intersection", "symbols": ["intersection", "_", { "literal": "&" }, "_", "nullable"], "postprocess": function (data) {
            return new Fragment('intersection', { type: data[0], type2: data[4] });
        }
    },
    { "name": "nullable", "symbols": ["type"], "postprocess": unpack },
    { "name": "nullable", "symbols": [{ "literal": "?" }, "type"], "postprocess": function (data) { return new Fragment('nullable', data[1]); } },
    { "name": "type", "symbols": ["simpleType"], "postprocess": unpack },
    { "name": "type$ebnf$1", "symbols": ["typeList"], "postprocess": id },
    { "name": "type$ebnf$1", "symbols": [], "postprocess": function () { return null; } },
    { "name": "type", "symbols": [{ "literal": "[" }, "_", "type$ebnf$1", "_", { "literal": "]" }], "postprocess": function (data) { return new Fragment('tuple', data[2]); } },
    { "name": "type", "symbols": ["type", { "literal": "[" }, "_", "unsigned_int", "_", { "literal": "]" }], "postprocess": function (data) {
            return new Fragment('array', { type: data[0], size: data[3] });
        }
    },
    { "name": "type$string$1", "symbols": [{ "literal": "[" }, { "literal": "]" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "type", "symbols": ["type", "type$string$1"], "postprocess": function (data) { return new Fragment('list', data[0]); } },
    { "name": "type$ebnf$2", "symbols": ["keyedTypeList"], "postprocess": id },
    { "name": "type$ebnf$2", "symbols": [], "postprocess": function () { return null; } },
    { "name": "type", "symbols": [{ "literal": "{" }, "_", "type$ebnf$2", "_", { "literal": "}" }], "postprocess": function (data) {
            var object = null;
            var pairs = data[2];
            pairs && pairs.forEach(function (pair) {
                if (!object)
                    object = {};
                object[pair.key] = pair;
            });
            return new Fragment('struct', object);
        } },
    { "name": "type$string$2", "symbols": [{ "literal": "]" }, { "literal": ":" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "type", "symbols": [{ "literal": "{" }, "_", { "literal": "[" }, "_", "simpleType", "_", "type$string$2", "_", "fragment", "_", { "literal": "}" }], "postprocess": function (data) {
            return new Fragment('map', { keyType: data[4], type: data[8] });
        }
    },
    { "name": "type$ebnf$3", "symbols": [] },
    { "name": "type$ebnf$3", "symbols": ["type$ebnf$3", /[a-zA-Z0-9]/], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "type$ebnf$4", "symbols": ["fragment"], "postprocess": id },
    { "name": "type$ebnf$4", "symbols": [], "postprocess": function () { return null; } },
    { "name": "type", "symbols": [/[a-z]/, "type$ebnf$3", { "literal": "{" }, "_", "type$ebnf$4", "_", { "literal": "}" }], "postprocess": function (data) {
            return new Fragment('named', { name: "" + data[0] + data[1].join(''), type: data[4] });
        }
    },
    { "name": "type", "symbols": [{ "literal": "(" }, "_", "fragment", "_", { "literal": ")" }], "postprocess": function (data) { return data[2]; } },
    { "name": "keyedTypeList", "symbols": ["keyTypePair"] },
    { "name": "keyedTypeList", "symbols": ["keyTypePair", "_", { "literal": "," }], "postprocess": function (data) { return [data[0]]; } },
    { "name": "keyedTypeList", "symbols": ["keyTypePair", "_", { "literal": "," }, "_", "keyedTypeList"], "postprocess": function (data) { return [data[0]].concat(data[4]); } },
    { "name": "keyTypePair$ebnf$1", "symbols": [/[a-zA-Z0-9_]/] },
    { "name": "keyTypePair$ebnf$1", "symbols": ["keyTypePair$ebnf$1", /[a-zA-Z0-9_]/], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "keyTypePair$ebnf$2", "symbols": [{ "literal": "?" }], "postprocess": id },
    { "name": "keyTypePair$ebnf$2", "symbols": [], "postprocess": function () { return null; } },
    { "name": "keyTypePair", "symbols": ["keyTypePair$ebnf$1", "_", "keyTypePair$ebnf$2", { "literal": ":" }, "_", "fragment"], "postprocess": function (data) {
            return ({ key: data[0].join(''), optional: Boolean(data[2]), type: data[5] });
        }
    },
    { "name": "typeList", "symbols": ["type"] },
    { "name": "typeList", "symbols": ["type", "_", { "literal": "," }], "postprocess": function (data) { return [data[0]]; } },
    { "name": "typeList", "symbols": ["type", "_", { "literal": "," }, "_", "typeList"], "postprocess": function (data) { return [data[0]].concat(data[4]); } },
    { "name": "simpleType$subexpression$1", "symbols": ["nullLiteral"] },
    { "name": "simpleType$subexpression$1", "symbols": ["boolean"] },
    { "name": "simpleType$subexpression$1", "symbols": ["char"] },
    { "name": "simpleType$subexpression$1", "symbols": ["number"] },
    { "name": "simpleType$subexpression$1", "symbols": ["dqstring"] },
    { "name": "simpleType", "symbols": ["simpleType$subexpression$1"], "postprocess": function (data) {
            return new Fragment('literal', data[0][0]);
        }
    },
    { "name": "simpleType$subexpression$2$string$1", "symbols": [{ "literal": "a" }, { "literal": "n" }, { "literal": "y" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$1"] },
    { "name": "simpleType$subexpression$2$string$2", "symbols": [{ "literal": "b" }, { "literal": "o" }, { "literal": "o" }, { "literal": "l" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$2"] },
    { "name": "simpleType$subexpression$2$string$3", "symbols": [{ "literal": "c" }, { "literal": "h" }, { "literal": "a" }, { "literal": "r" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$3"] },
    { "name": "simpleType$subexpression$2$string$4", "symbols": [{ "literal": "f" }, { "literal": "l" }, { "literal": "o" }, { "literal": "a" }, { "literal": "t" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$4"] },
    { "name": "simpleType$subexpression$2$string$5", "symbols": [{ "literal": "i" }, { "literal": "n" }, { "literal": "t" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$5"] },
    { "name": "simpleType$subexpression$2$string$6", "symbols": [{ "literal": "s" }, { "literal": "t" }, { "literal": "r" }, { "literal": "i" }, { "literal": "n" }, { "literal": "g" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$6"] },
    { "name": "simpleType$subexpression$2$string$7", "symbols": [{ "literal": "v" }, { "literal": "o" }, { "literal": "i" }, { "literal": "d" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType$subexpression$2", "symbols": ["simpleType$subexpression$2$string$7"] },
    { "name": "simpleType", "symbols": ["simpleType$subexpression$2"], "postprocess": function (data) {
            return new Fragment('primitive', data[0][0]);
        }
    },
    { "name": "simpleType", "symbols": ["genericName"], "postprocess": function (data) { return new Fragment('generic', { name: data[0] }); } },
    { "name": "simpleType$string$1", "symbols": [{ "literal": "e" }, { "literal": "x" }, { "literal": "t" }, { "literal": "e" }, { "literal": "n" }, { "literal": "d" }, { "literal": "s" }], "postprocess": function (d) { return d.join(''); } },
    { "name": "simpleType", "symbols": ["genericName", "_", "simpleType$string$1", "_", "nullable"], "postprocess": function (data) {
            return new Fragment('generic', { name: data[0], extends: data[4] });
        }
    },
    { "name": "genericName$ebnf$1", "symbols": [] },
    { "name": "genericName$ebnf$1", "symbols": ["genericName$ebnf$1", /[a-zA-Z0-9_]/], "postprocess": function (d) { return d[0].concat([d[1]]); } },
    { "name": "genericName", "symbols": [/[A-Z_]/, "genericName$ebnf$1"], "postprocess": function (data) { return "" + data[0] + data[1].join(''); } }
];
exports.ParserStart = "grammar";
//# sourceMappingURL=index.js.map